## dgit 13.16

=== po/Makefile ===
# dgit message translation machinery
#
# Translators: there is no need to look at this file.  It contains
# complicated machinery which you do not need to understand :-).
# See po/README instead.

# Copyright (C)2018 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# ----- metaprogramming (translators, please ignore all this) -----
#
# We present translators with a single file po/messages.pot containing
# all the messages for the translated programs in dgit.deb and
# git-debrebase.deb.  This also includes the messages from the shared
# perl modules.
#
# But when we make the .debs, we want to ship in each .deb the
# messages for that .deb, only (but including the common parts).
#
# So we generate three intermediate .pots,
#   .{dgit,git-debrebase,common}.pot
# and merge them to make messages.pot.
#
# From the translations we generate two .mo files for each output
# language: {dgit,git-debrebase}.mo -- including the common messages.
#
# To avoid dirtying the tree whenever we do `make install',
# we honour SUPPRESS_PO_UPDATE, to be used like this
#   make install prefix=$(prefix) SUPPRESS_PO_UPDATE=1

all: messages.pot mofiles

include ../i18n-common.make

.%.potfiles:
	$S $e; echo ../$*; $f

.common.potfiles:
	$S $e; find ../Debian -name \*.pm; $f

.%.make: .%.potfiles Makefile part.make
	$S $e; \
	 sed 's/~/$*/g' part.make; \
	 sed "s#^#.$*.pot: #" $<; \
	$f

-include .dgit.make
-include .git-debrebase.make
-include .common.make

POFILES := $(wildcard *.po)
LANGS := $(basename $(POFILES))

MOFILES = $(foreach part,$(filter-out common,$(PARTS)), \
	$(addprefix mo/$(part)_, $(POFILES:.po=.mo)))

messages.pot: $(if $(SUPPRESS_PO_UPDATE),,$(POTS))
	$S msgcat --to-code=UTF-8 $^		>.messages.0.tmp
	$S ( ./remove-potcdate <$@ ||: )	>.messages.1.tmp
	$S ./remove-potcdate <.messages.0.tmp	>.messages.2.tmp
	$S cmp -s .messages.[12].tmp || mv -v .messages.0.tmp $@
	@echo 'Updated $@.'

%.mo: %.po
	$S msgfmt -o $@ $<

XGETTEXT_OPTS += -Lperl -k__ -kf_ -ki_
XGETTEXT_OPTS += --from-code=UTF-8
XGETTEXT_OPTS += --package-name=dgit --package-version=ongoing
# The --package-* avoids this error from make check's `msgfmt -c'
#  warning: header field 'Project-Id-Version' still has the initial default value

%.pot:
	$S TZ=UTC xgettext $(XGETTEXT_OPTS) $^ -o $@.tmp && $f

mofiles: $(MOFILES)
	@echo 'Generated mo/*.mo (binary translated messages) OK.'

install: all
	set -e; for file in $(MOFILES); do \
		lang=$${file#*_}; lang=$${lang%.mo}; \
		part=$${file#mo/}; part=$${part%%_*}; \
		d=$(DESTDIR)$(prefix)/share/locale/$$lang/LC_MESSAGES; \
		install -d $$d; \
		install -m 0644 $$file $$d/$$part.mo; \
	done

clean:
	rm -f .*.make .*.potfiles .*.pot .*.tmp
	rm -rf mo

%.po: $(if $(SUPPRESS_PO_UPDATE),,messages.pot)
	@echo -n "Merging messages.pot and $@ "
	$S if test -f $@; then \
		msgmerge --previous $@ messages.pot -o $@.new; \
	else \
		msgcat --lang=$* messages.pot >$@.new; \
	fi
	$S mv -f $@.new $@
	$S msgfmt -o /dev/null --statistics $@

.PRECIOUS: .%.potfiles

pofiles: $(POFILES)

update: pofiles check

check: $(if $(SUPPRESS_PO_UPDATE),,pofiles)
	$S set -e; for file in $(POFILES); do \
		lang=`echo $$file | sed 's/\.po//'`; \
		printf "$$lang: "; \
		msgfmt -o /dev/null -c -v --statistics $$lang.po;\
	done

=== po4a/Makefile ===
# dgit document translation machinery
#
# Translators: there is no need to look at this file.  It contains
# complicated machinery which you do not need to understand :-).
# See po/README instead.

# Copyright (C)2018 Ian Jackson
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

# ----- devel docs (translators, please ignore all this) -----
#
# We use po4a for everything.
#
# po4a is nicely automatic for all the po handling, and the config
# file makes nice documentation, but it really really likes to dirty
# the tree.  And we want to automatically list the documents and the
# translation languages which it doesn't make easy.
#
# The approach I have chosen is as follows:
#
# po4a.cfg
#
#   This is autogenerated.  But also, we invite translators to add
#   their own language to it.  The resulting merge
#   conflict/discrepancy will be just an alphabetical ordering
#   discrepancy, since our generation script scans the available po
#   files.
#
#   Generation is done by a shell script, ./generate-po4a.cfg.
#
#   make targets:  po4a.cfg           # many others imply this
#                  po4a.cfg.check     # fails if out of date
#
# *.pot, *.po
#
#   As far as translators are concerned, generated and maintained by
#   po4a and committed to git.  As for the developers, we update this
#   occasionally just by running po4a.
#
#   make targets:  default           } mean
#                  pofiles           }  the same
#
# Translations for translators:
#
#   make targets:  preview.LANG
#                  translated
#
# Translated document source-language files (eg, translated pod):
#
#   Like with normal po things, the tools don't like to generate
#   output without updating (dirtying) the .po files.  But with po4a
#   this is really hard to avoid.  So we use a linkfarming technique.
#
#   make targets:  translated-only
#
# Translated output files (roff format, from pod2man):
#
#   We have sort of lost the usual make rule information by now
#   about targets and what to build.  Only po4a knows which
#   translated files are supposed to exist.  So we have a shell
#   script which reuses the top-level Makefile to run pod2man
#   where appropriate, and generate a further even-more-output-ish
#   tree.
#
#   make targets:  install
#
# Check:
#
#   make targets:  check
#                  pairwise-pocheck.check


default: pofiles

include ../i18n-common.make
PO4A ?= po4a

all update: translated

check: po4a.cfg.check pairwise-pocheck.check

pofiles: po4a.cfg
	$(PO4A) --no-translations $<

translated: po4a.cfg
	$(PO4A) $<

po4a.cfg: generate-po4a.cfg
	./$< $o

po4a.cfg.check: generate-po4a.cfg
	./$< >$@.tmp
	diff po4a.cfg $@.tmp

potfiles.check:
	ls $(addsuffix .pot, $(subst .,_, $(shell ./list-documents)))

pairwise-pocheck.check:
	./pairwise-pocheck

t = ../.po4a.translated-only
p = ../po4a

translated-only: po4a.cfg pairwise-pocheck.check
	rm -rf $t && mkdir $t
	cd $t && ln -s $p/*.po $p/*.pot $p/po4a.cfg .
	cd $t && $(PO4A) po4a.cfg
	! test -d $t/translated || \
	cp -al --remove-destination $t/translated .

.po4a.%.cfg: po4a.cfg Makefile
	$S perl -p -e 's{^(\[po4a_langs\]).*}{$$1 $*};' \
		-e 's{:translated/man}{:.$*.translated/man}' \
		$< $o

.PRECIOUS: .po4a.%.cfg

pairwise-pocheck.%.check:
	@tclsh /dev/null || printf ':;:; Please run   apt-get install tcl\n'
	./pairwise-pocheck $*

preview.%: .po4a.%.cfg pairwise-pocheck.%.check
	$S $(PO4A) $<
	$S ./install-documents >/dev/null .$*.translated $@
	@ echo '# runes to preview the various final translated manpages:'
	$S find $@ -type f -printf 'man -l %p\n'

# We can't really use timestamps to drive po4a
.PHONY: preview.% translated

install: translated-only
	./install-documents translated $(DESTDIR)

## dgit 13.17~bpo13+1

=== tests/Makefile ===
# usage: tests/using-intree make -f tests/Makefile
# optionally setting
#   TESTSCRIPTS='tests/tests/foo tests/tests/bar')
#   DGIT_TEST_RETRY_COUNT=<a smallish integer>

TESTSCRIPTS ?= $(shell tests/enumerate-tests)
TESTNAMES := $(notdir $(TESTSCRIPTS))

all: $(foreach t,$(TESTNAMES),tests/tmp/$t.ok)
	@echo "ALL PASSED$${DGIT_TESTS_PROGRESSIVE+ AT SOME POINT}"

tests/tmp/%.ok: tests/tests/%
ifeq ($(DGIT_TEST_RETRY_COUNT),)
	$(DGIT_TEST_RUN_PFX) tests/tests/$* >tests/tmp/$*.log 2>&1
else
	@for retry in $$( seq 1 $(DGIT_TEST_RETRY_COUNT) ); do		\
		echo "[$$retry] $*";					\
	$(DGIT_TEST_RUN_PFX) tests/tests/$* >tests/tmp/$*.$$retry.log 2>&1; \
		rc=$$?;							\
		if [ $$rc = 0 ]; then exit 0; fi;			\
		echo >&2 "[$$retry] $* TEST FAILED $$rc";		\
	done; exit $$rc
endif
	@touch $@

=== debian/changelog ===
dgit (13.17~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 11 Nov 2025 13:41:47 +0000

dgit (13.17) unstable; urgency=medium

  git-debrebase:
  * Merge resolution: tolerate nested vanilla merges, and maybe
    deal bettter with other unusual situations.
    Closes: #1116600.  [Report from David Bremner]

  dgit:
  * Try downloading missing artefacts from incoming.d.o/debian-buildd.
    Reduces apparent archive skew, eg with "dgit fetch".
    In tag2upload, will better handle quick re-upload after a new upstream.
    Closes: #1111728.  [Suggested by Colin Watson]
  * download-unfetched-origs: Check that bpd exists, failng early if not.
  * Report filename, not url, in "downloading" message, unless all are 404.
  * On an archive file mismatch, print lengths too, not just hashes.

  git-debpush [Sean Whitton]:
  * Minor improvements to some mesages.

  Documentation:
  * tag2upload: Add some xrefs in TAG2UPLOAD-DESIGN.txt.
  * Retrospectively add two missed bug Closes to entries for 12.12 and 12.1.

  i18n:
  * nl: Updated messages and dgit-user(7).
    Closes: #1115336, #1115338.  [Frans Spiesschaert]
  * pt: Added git-debrebase(5); updated tag2upload(5).
    Closes: #1118296.  [Américo Monteiro]

  Supporting work:
  * Much refactoring of download handlng.
  * Better testing of download-unfetched-origs.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 24 Oct 2025 19:06:20 +0100

## dgit 13.17

=== changelog ===
example (1.0-1.100) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:54 +0100

example (1.0-1.99) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.98) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.97) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.96) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.95) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.94) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.93) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.92) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.91) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.90) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.89) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.88) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:53 +0100

example (1.0-1.87) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.86) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.85) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.84) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.83) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.82) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.81) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.80) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.79) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.78) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.77) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.76) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.75) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:52 +0100

example (1.0-1.74) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.73) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.72) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.71) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.70) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.69) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.68) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.67) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.66) unstable; urgency=medium

  * Dummy update to make long changelog

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 16 Oct 2016 18:17:51 +0100

example (1.0-1.65) unstable; urgency=medium



=== control ===
Source: ruby-rails-3.2
Section: ruby
Priority: optional
Maintainer: Debian Ruby Extras Maintainers <pkg-ruby-extras-maintainers@lists.alioth.debian.org>
Uploaders: Antonio Terceiro <terceiro@debian.org>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50~), gem2deb (>= 0.3.0~)
Standards-Version: 3.9.3
Vcs-Git: git://git.debian.org/pkg-ruby-extras/ruby-rails-3.2.git
Vcs-Browser: http://git.debian.org/?p=pkg-ruby-extras/ruby-rails.git;a=summary
Homepage: http://www.rubyonrails.org
XS-Ruby-Versions: all

Package: ruby-rails-3.2
Architecture: all
XB-Ruby-Versions: ${ruby:Versions}
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ruby-activesupport-3.2 (>= 3.2.6),
 ruby-activesupport-3.2 (<< 3.2.6.),
 ruby-actionpack-3.2 (>= 3.2.6),
 ruby-actionpack-3.2 (<< 3.2.6.),
 ruby-activerecord-3.2 (>= 3.2.6),
 ruby-activerecord-3.2 (<< 3.2.6.),
 ruby-activeresource-3.2 (>= 3.2.6),
 ruby-activeresource-3.2 (<< 3.2.6.),
 ruby-actionmailer-3.2 (>= 3.2.6),
 ruby-actionmailer-3.2 (<< 3.2.6.),
 ruby-railties-3.2 (>= 3.2.6),
 ruby-railties-3.2 (<< 3.2.6.),
 bundler,
 rubygems-integration
Description: MVC ruby based framework geared for web application development
 Rails is a full-stack, open-source web framework in Ruby for writing
 real-world applications.
 .
 Being a full-stack framework means that all layers are built to work
 seamlessly together. That way you don't repeat yourself and you can
 use a single language from top to bottom. Everything from templates to
 control flow to business logic is written in Ruby.
 .
 This package provides Rails version 3.2.

Package: rails3
Architecture: all
Depends: ruby-rails-3.2, ${shlibs:Depends}, ${misc:Depends}
Description: MVC ruby based framework geared for web application development
 Rails is a full-stack, open-source web framework in Ruby for writing
 real-world applications.
 .
 Being a full-stack framework means that all layers are built to work
 seamlessly together. That way you don't repeat yourself and you can
 use a single language from top to bottom. Everything from templates to
 control flow to business logic is written in Ruby.
 .
 This package is a convenience metapackage that depends on ruby-rails-3.2.

=== debian/control ===
Source: dgit
Section: devel
Priority: optional
Maintainer: Debian tag2upload Delegates <dgit-owner@debian.org>
Uploaders:
 Ian Jackson <ijackson@chiark.greenend.org.uk>,
 Sean Whitton <spwhitton@spwhitton.name>
Standards-Version: 4.4.0.0
Build-Depends: debhelper-compat (= 12), gettext, po4a, tcl
Vcs-Git: https://salsa.debian.org/dgit-team/dgit.git
Vcs-Browser: https://salsa.debian.org/dgit-team/dgit

Package: dgit
Depends: perl, libdpkg-perl, git-core, devscripts, dpkg-dev,
         ${misc:Depends}, git-buildpackage, liblist-moreutils-perl,
         liblocale-gettext-perl,
         coreutils (>= 8.23-1~),
         libdigest-sha-perl, dput, curl, apt,
         libjson-perl, ca-certificates,
         libtext-iconv-perl, libtext-glob-perl, libwww-curl-perl,
         libtext-csv-perl, python3
Recommends: ssh-client, distro-info-data, liburi-perl
Suggests: sbuild | pbuilder | cowbuilder
Architecture: all
Description: git interoperability with the Debian archive
 dgit (with the associated infrastructure) makes it possible to
 treat the Debian archive as a git repository.
 .
 dgit push constructs uploads from git commits
 .
 dgit clone and dgit fetch construct git commits from uploads.

Package: git-debrebase
Depends: perl, git-core, libdpkg-perl, libfile-fnmatch-perl, devscripts,
         liblocale-gettext-perl,
         ${misc:Depends}
Recommends: dgit, git-buildpackage
Architecture: all
Description: rebasing git workflow tool for Debian packaging
 git-debrebase is a tool for representing in git, and manipulating,
 Debian packages based on upstream source code.
 .
 git-debrebase is an alternative to workflows including git-dpm,
 gbp pq, and direct use of quilt patches.

Package: git-debpush
Depends: git, gpg, gpg-agent, libdpkg-perl, ${misc:Depends}
Replaces: devscripts (<< 2.25.18)
# No "Breaks: devscripts (<< 2.25.18)" because:
# - devscripts doesn't hard-depend on git-deborig
# - it would break installability of this .deb on anything older than
#   forky, and we try to support installability on older Debian stable
#   releases as much as possible.
# Also cf. <https://bugs.debian.org/592610#64>.
Architecture: all
Description: client script for git pushing to Debian-style archives
 git-debpush is a script to create and push a specially formatted
 signed git tag.  The metadata in the tag indicates that the tagged
 commit should be pushed (or "uploaded") to a Debian-style archive.
 .
 Tags generated by this script can be read by an intermediary service,
 which performs any conversion that's needed (such as producing and
 signing a .dsc and .changes), and then uploads the result to the
 Debian-style archive on your behalf.
 .
 This package also ships git-deborig, a program which tries to produce
 Debian orig.tar using git-archive(1).  (This program used to be in the
 'devscripts' package.)

Package: dgit-infrastructure
Depends: ${misc:Depends}, perl, git-core, gpgv, chiark-utils-bin,
         libjson-perl, libdigest-sha-perl, libdbd-sqlite3-perl, sqlite3,
         libdpkg-perl,
         liburi-perl, libmime-tools-perl,
         liblocale-gettext-perl
Recommends: dgit (>= 11.7~)
Architecture: all
Description: dgit server backend infrastructure
 This package contains tools which are useful for setting up a dgit
 git depository.  You probably want dgit, the client package, instead
 of dgit-infrastructure.

=== rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -f bin/fel-pio.* bin/*.sunxi bin/*.scr

override_dh_auto_build:
	dh_auto_build
	mkimage -A arm -T script -d bin/ramboot.uboot-sh bin/ramboot.scr

override_dh_auto_install: PKG := debian/sunxi-tools
override_dh_auto_install:
	dh_install
	install -m0755 usb-boot $(PKG)/usr/bin/sunxi-usb-boot
	install -m0755 fel $(PKG)/usr/bin/sunxi-fel
	install -m0755 fexc $(PKG)/usr/bin/sunxi-fexc
	install -m0755 bootinfo $(PKG)/usr/bin/sunxi-bootinfo

	ln -s sunxi-fexc $(PKG)/usr/bin/fex2bin
	ln -s sunxi-fexc $(PKG)/usr/bin/bin2fex
	install -m0644 bin/ramboot.scr $(PKG)/usr/share/sunxi-tools/ramboot.scr

	# To consider in the future:
	# nand-part:  armhf only
	# fel-pio:    debug/early bringup only
	# jtag-loop:  debug/early bringup only
	# fel-sdboot: potentially useful, but requires mksunxiboot
	# boot_head:  broken u-boot only

=== watch ===
version=3
http://pkg-ruby-extras.alioth.debian.org/cgi-bin/gemwatch/rails .*/rails-(.*).tar.gz

## dgit 13.18~bpo13+1

=== debian/changelog ===
dgit (13.18~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 15 Dec 2025 11:11:37 +0000

dgit (13.18) unstable; urgency=medium

  git-debpush:
  * Disable interactively overriding some check failures.
    For check failures which indicate the upload will almost certainly fail,
    just exit.  [Prompted by feedback from Stuart Prescott]
  * git-debpush(1): Document some checks for which docs were missing.
  * git-debpush(1): One minor presentational tweak.

  tag2upload service:
  * Restart tag2upload-oracled on dgit-infrastructure.deb upgrades.
    Closes: #1117735.
  * Take a lock of /var/run/reboot-lock on the Oracle and Builder.
    Closes: #1118197.
  * Use our new custom tmpfs as TMPDIR on the Builder.
    Closes: #1118190.
  * tag2upload-builder-rebuild: Take the Debian release from the crontab.
  * Upgrade the Builder's Podman container bookworm->trixie.

  i18n:
  * pt: Add dgit(7); add git-debpush(1); update others.
    Closes: #1118952.  [Américo Monteiro]

  Test suite:
  * Rebuild dgit-infrastructure.deb before commencing Salsa CI.
    This is necessary because it can now gain a versioned dependency on
    init-system-helpers.
  * Delete t2u-integration-bookworm Salsa CI job.

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 12 Dec 2025 15:49:26 +0000

## dgit 13.19~bpo13+1

=== debian/changelog ===
dgit (13.19~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 22 Dec 2025 10:17:23 +0000

dgit (13.19) unstable; urgency=medium

  tag2upload development:
  * t2u oracled: Logging improvements.  [Sean Whitton]
  * t2u oracle-to-manager protocol document: introduce protocol 6,
    with provision for retries, and reporting of whether email sent.
    Not yet implemented.  See #1112106; tag2upload-service-manager#37.
    [Ian Jackson with assistance from Sean Whitton]

  Testing:
  * stunt changelog parser: cope with 'filename' in %options in innards.
    [Report from Guillem Jover]  Closes: #1123654.
  * New dev helper utility tests/install-deps-remove-debs.
  * Fix a protocol violation (race) by fake t2usm.
  * t2u-integration: don't kill the whole process group (race fix).
  * CI: Test against Debian testing.  See salsa-ci-team/pipeline#532.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Fri, 19 Dec 2025 14:43:29 +0000

## dgit 13.20

=== debian/changelog ===
dgit (13.20) unstable; urgency=medium
  
  tag2upload development:
  * t2u o2m protocol: Restore the last attempt MESSAGE.
    [Mistake spotted by by Sean Whitton]

  Fixes to cope with new libdpkg-perl (Closes: #1123583):
  * git-deborig: Pass no_check as well as nocheck to spawn.
  * Dgit.pm: Provide and use reimplementation of is_native.
  * git-deborig: Suppress a new warning about is_native.

  i18n:
  * nl: Update Dutch message
    [Frans Spiesschaert]  Closes: #1120337.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Tue, 23 Dec 2025 19:17:30 +0000

## dgit 14.0

=== debian/changelog ===
dgit (14.0) unstable; urgency=medium

  Possibly-breaking changes to dgit build subcommands:
  * dgit sbuild, pbuilder, cowbuilder: Run sbuild, pbuilder or cowbuilder
    in the original invocation directory, rather than the build-products-dir.
    Pass the the bpd via the appropriate command line option.
    [Report from Jochen Sprickerhof]  Closes: #1124014.
  * dgit pbuilder, cowbuilder: Pass -us -uc to dpkg-buildpacckage.

  Possibly-incompatible change in gitattributes handling:
  * Suprress all transforming gitattributes.
    - dgit suppresses export-* (in dgit clone, setup-new-tree, etc.)
    - git-deborig and tag2upload suppress non-export-* gitattributes.
    Generated tarballs/.origs will change, for affected git trees.
    [Report from Simon Josefsson]  Closes: #1111548.

  Synthetic commits' metadata change:
  * Use a fixed name & email address for the committer of dsc imports,
    rather than (ab)using the author details (from the package changelog).
    (dgit 14.x's imports' git history will not match earlier dgit's.)
    [Report from Cyril Brulebois via Philip Hands]  Closes: #1124226.

  i18n:
  * pt: Updated git-debpush(1), new translation dgit(1).
    [Américo Monteiro]  Closes: #1124136.

  Bugfixes:
  * git-deborig now never leaves behind an unwanted change to the user's
    .git/info/attributes.  Instead, on certain error paths, it can now leave
    the working tree's .gitattributes file dirtied.  Improves #1124383.
  * Use a .invalid domain (rather than example.com) for the non-user-facing
    internal commits in the reflog-based quilt fixup cache.

  tag2upload development [Sean Whitton]:
  * tag2upload-oracled: Speak manager protocol version 6.  
  * tag2upload-oracled: Improved logging.

  Supporting work:
  * Improvements to ProtoConn.  [Sean Whitton]
  * Overhaul of tag2upload-oracled/dgit-repos-server API.  [Sean Whitton]
  * Improvements to test suite.  [Ian Jackosn & Sean Whitton]

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Wed, 31 Dec 2025 15:24:52 +0000

## dgit 14.1~bpo13+1

=== debian/changelog ===
dgit (14.1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 04 Jan 2026 11:00:54 +0000

dgit (14.1) unstable; urgency=medium

  * tests: gitattributes: Add git-deborig dependencies to fix autopkgtests.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 01 Jan 2026 19:11:29 +0000

=== debian/rules ===
#!/usr/bin/make -f

# dgit
# Integration between git and Debian-style archives
#
# Copyright (C)2013-2019 Ian Jackson
# Copyright (C)2019      Sean Whitton
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

export prefix=/usr

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol
	set -e; \
	 cd debian/dgit; \
	 v=$$(perl -ne 'print if s/^version:\s+//i' DEBIAN/control); \
	 perl -i -pe "s/UNRELEASED/$$v/g if m/###substituted###/" usr/bin/dgit

override_dh_auto_clean:
	dh_auto_clean
	make -C po clean

globalperl=/usr/share/perl5

override_dh_auto_install: specpkg_install_gdp \
 specpkg_install_gdr \
 specpkg_install_infra
	make install prefix=/usr DESTDIR=debian/dgit
	make -C po install prefix=/usr DESTDIR=../debian/tmp \
		SUPPRESS_PO_UPDATE=1 S=''
	mv debian/dgit/usr/bin/git-playtree-setup debian/dgit/usr/share/dgit
	make -C po4a install DESTDIR=../debian/tmp S=''

# At debhelper compat level 14, dh_installsystemduser will handle restarting
# tag2upload-oracled on package upgrade: see #1117735.
# We want this for the live service, but don't want to upgrade the whole
# package to compat 14 to preserve buildability on older releases of Debian.
# Debian::Debhelper::Dh_Lib::MAX_COMPAT_LEVEL has been available for a long
# time; if it isn't, that won't go by silently because intcmp will exit the
# build when it gets a non-numeric argument.
MAX_COMPAT_LEVEL=$(shell perl -MDebian::Debhelper::Dh_Lib \
		-we'print Debian::Debhelper::Dh_Lib::MAX_COMPAT_LEVEL')
override_dh_installsystemduser:
	$(intcmp $(MAX_COMPAT_LEVEL),14,,DH_COMPAT=14) \
		dh_installsystemduser --name=tag2upload-oracled --no-enable

override_dh_missing:
	dh_missing --fail-missing

specpkg_install_gdp: p=git-debpush

specpkg_install_gdr: p=git-debrebase
specpkg_install_gdr: pm=GDR

specpkg_install_infra: p=dgit-infrastructure
specpkg_install_infra: pm=Infra

define specpkg_install_common
	make install-$(tok) prefix=/usr DESTDIR=debian/$(p) perldir=$(specperl)
#	# Most of the Perl modules in this package live in
#	# $(specperl).  The exception is Debian::Dgit::Infra, which
#	# lives in $(globalperl) and adds $(specperl) to @INC.
#	# We also abuse this for git-playtree-setup.  In .debs, this
#	# goes in the per-.deb @INC dir.  See Dgit.pm::playtree_setup.
	set -ex; \
	 base=debian/$(p); \
	 mod=Debian/Dgit/$(pm).pm; \
	 src=$${base}$(specperl)/$${mod}; \
	 dst=$${base}$(globalperl)/$${mod}; \
	 mkdir -p $${dst%/*}; \
	 mv -f $$src $$dst; \
	 install -m 755 git-playtree-setup $${base}$(specperl); \
	 perl -i -p -e 'next unless m/###substituted###/;' \
		-e 'next unless s/^# (?=unshift \@INC,)//;' \
		-e 'die unless s{q\{\S+\}}{q{$(specperl)}};' \
		 $$dst
endef

specpkg_install_%: tok=$*
specpkg_install_%: specperl=/usr/share/dgit/$(tok)/perl5
specpkg_install_%:
	$(specpkg_install_common)

specpkg_install_gdp: tok=gdp
specpkg_install_gdp: pm=GDP
specpkg_install_gdp: specperl=/usr/share/dgit/gdp/perl5
specpkg_install_gdp:
	$(specpkg_install_common)
	set -x; perl -i -pe 'next unless m/###substituted###/;' \
 -e 's{^(git_playtree_setup)=.*}{$$1=$(specperl)/git-playtree-setup};' \
		debian/$(p)/usr/bin/*

debian/tests/control: tests/enumerate-tests debian/tests/control.in
	$< gencontrol >$@.new && mv -f $@.new $@

debian/tests/control: tests/lib-core tests/lib-restricts
debian/tests/control: tests/tests $(wildcard tests/tests/*[^~#])

## dgit 14.2~bpo13+1

=== debian/changelog ===
dgit (14.2~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 14 Jan 2026 11:17:47 +0000

dgit (14.2) unstable; urgency=medium

  tag2upload:
  * Send emails to the uploading user in all failure paths, using the
    address in the tag's tagger line (from the Manaager) if necessary,
    and by telling the Manager `email unreported` when that's not possible.
  * If we a job arrives when a host is about to reboot, call it a retriable
    failure.  (Not wholly effective; see also #1125239.)  [Sean Whitton]

  tag2upload development:
  * o2m protocol version 7, convey the user's email address,
  * Move retry schedule docs to tag2upload-service-manager.git.
  * Rename "noreply" config to "from".  (We're using a deliverable address.)
  * Many improvements to oracled's logging.  [Sean Whitton, Ian Jackson]
  * tests: t2u-integration: Provide configuration used by t2usm email feature.
  * Many supporting (and testing) changes.  [Sean Whitton, Ian Jackson]

  Testing:
  * Unset http_proxy (to make tests more self-contained).
  * When polling for perhaps a long time, start much faster.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 11 Jan 2026 23:40:11 +0000

=== debian/tests/control ===
Tests: baredebian-multitar baredebian-plusgit baredebian-push baredebian-tarball
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl, quilt, git-debpush, git-debrebase, git-buildpackage

Tests: build-modes-gbp
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl, git-buildpackage

Tests: clone-reprepro downstream-gitless
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl, reprepro

Tests: dpkgsourceignores-docs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl
Restrictions: x-dgit-intree-only

Tests: defdistro-dsd-clone-drs dsd-clone-drs
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl
Restrictions: x-dgit-intree-only x-dgit-git-only

Tests: alternating-dgit clone-gitnosuite clone-nogit clone-skew drs-clone-nogit dsd-clone-nogit ftpmasterapi-http
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl, libhttp-server-simple-static-perl

Tests: gdr-import-dgit
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl, git-debrebase, git-buildpackage, libhttp-server-simple-static-perl

Tests: gdr-merge-conflicts
Tests-Directory: tests/tests
Depends: chiark-utils-bin, faketime, git-debrebase, git-buildpackage, quilt

Tests: cmd-override gdr-diverge-nmu gdr-diverge-nmu-dgit gdr-edits gdr-fresh gdr-import-dgitview gdr-import-nostitch gdr-makepatches7 gdr-merge gdr-subcommands gdr-unprocessable gdr-unprocessable-hints
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl, git-debrebase, git-buildpackage

Tests: gdr-newupstream gdr-viagit
Tests-Directory: tests/tests
Depends: chiark-utils-bin, faketime, git-debrebase, git-buildpackage

Tests: git-deborig
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl, git-debpush

Tests: gitattributes
Tests-Directory: tests/tests
Depends: dgit, dgit-infrastructure, devscripts, debhelper (>=8), fakeroot, build-essential, chiark-utils-bin, bc, faketime, liburi-perl, bsdgames, man-db, git-man, git-debpush

Tests: hint-testsuite-triggers
Tests-Directory: tests/tests
Depends: gnupg, patch, diffutils

## dgit 14.3

=== debian/changelog ===
dgit (14.3) unstable; urgency=medium

  tag2upload development [Ian Jackson]:
  * Make some failures retriable:
    - when 'dgit download-unfetched-origs' fails to query the archive
      (e.g. a connection timeout)
    - when regenerating the orig fails but the correct one might become
      available via the archive later
    - when fetching from salsa fails with a HTTP 500 series error
      Closes: #1112106.
  * Use actual job status in email Subject.
    Main change is that users will see "irrecoverable" instead of "failed".
  * Define o2m protocol version 8 to convey software versions.
  * Include the last attempt message on in the summary, not the transcript.
  * tag2upload-obtain-origs: Fix an argument checking bug.
  * When running tag2upload-* scripts fails, put script name in the report.
  * Supporting internal changes, including breaking out a new script
    'tag2upload-fetch-inputs'.

  tag2upload-oracled:
  * New --version option.

  Documentation:
  * dgit-maint-{debrebase,merge,gbp,native}(7):
    Say to upload with git-debpush.
  * dgit-maint-bpo(7), dgit-sponsorship(7), dgit-nmu-simple(7):
    Mention git-debpush where appropriate.
  * dgit-maint-{debrebase,merge}(7): Always push to salsa.
  * dgit-maint-debrebase(7): Recommend 'git debrebase quick',
    not 'git debrebase', right before uploading.  Closes: #1111233.
  * dgit(1): Fix a formatting error.  [Ian Jackson]

  i18n [Américo Monteiro]:
  * pt: New translation for dgit's messages.  Closes: #1125493.
  * pt: Updated dgit(1), dgit-downstream-dsc(7).  Closes: #1125499.

  Test suite [Ian Jackson]:
  * t2u-email: Add bounds so that we detect text added to beginning and end.
  * t2u: When grepping e-mails, grep only the body parts.
  * http-static-server: Yield better HTTP status codes.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 17 Jan 2026 14:58:07 +0000

## dgit 14.4

=== debian/changelog ===
dgit (14.4) unstable; urgency=medium

  tag2upload development [Sean Whitton]
  * oracled: Speak manager protocol version 8, reporting software versions.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 19 Jan 2026 22:07:51 +0000

## dgit 14.5~bpo13+1

=== debian/changelog ===
dgit (14.5~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Thu, 29 Jan 2026 17:55:18 +0000

dgit (14.5) unstable; urgency=medium

  Manpage fixes (fixes warnings from new groff [Colin Watson]:
  * dgit(1): Remove duplicate `.TP` request.
  * tests: manpages-format: Ignore font name warnings

  tag2upload development:
  * Fixes relating to email reports:
    - Do not CC the tag signer if we're not emailing the tagger.
    - On failed last attempt, report "failed" in X-headers and Subject.
    - Fix a fd concurrency bug which can garble gpg output in email reports.
    - Wrap recipient headers.
    - oracle not longer wrongly says "email reported" on retriable failure
      (this bug would prevent the ultimate report to the user).
    - Restore the inclusion of the exit status from tag2upload-obtain-origs.
  * Fix and improve reporting of software versions by oracled
    [Sean Whitton and Ian Jackson]
  * oracle-to-manager protocol clarifications/corrections.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 26 Jan 2026 21:06:14 +0000

## dgit 14.6

=== debian/changelog ===
dgit (14.6) unstable; urgency=medium

  * tests: Set SEQUOIA_CRYPTO_POLICY to work around apt's
    date-based SHA1 deprecation, which trips on our test keys.
    [Report from Simon McVittie]  Mitigates #1126793.
  * tests: t2u-gbp: Avoid spawning an editor if run interactively.

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Sun, 01 Feb 2026 16:02:24 +0000

## dgit 14.7~bpo13+1

=== debian/changelog ===
dgit (14.7~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 05 Feb 2026 11:13:38 +0000

dgit (14.7) unstable; urgency=medium

  tag2upload development:
  * tag2upload-oracled: Provide complete error message when reboot lock held.

  Fixes for gnupg/sqv incompatibilities in tests:
  * Update key self-cert hashes to fix test failure complaining about SHA1.
    Closes: #1126793.  [Report and suggestion from Simon McVittie]
  * Migrate to new gnupg secret key format for in-tree keys.
  * Revert attempted use of SEQUOIA_CRYPTO_POLICY (which is broken).

 -- Ian Jackson <ijackson@chiark.greenend.org.uk>  Mon, 02 Feb 2026 20:16:08 +0000

## dgit 14.7

=== Makefile ===
# dgit
# Integration between git and Debian-style archives
#
# Copyright (C)2013-2018 Ian Jackson
# Copyright (C)2019,2024 Sean Whitton
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

INSTALL=install
INSTALL_DIR=$(INSTALL) -d
INSTALL_PROGRAM=$(INSTALL) -m 755
INSTALL_DATA=$(INSTALL) -m 644

POD2MAN = pod2man --release="Debian Project" --date="dgit+tag2upload team"

prefix?=/usr/local

bindir=$(prefix)/bin
mandir=$(prefix)/share/man
perldir=$(prefix)/share/perl5
man1dir=$(mandir)/man1
man5dir=$(mandir)/man5
man7dir=$(mandir)/man7
infraexamplesdir=$(prefix)/share/doc/dgit-infrastructure/examples
infradebiandir=$(prefix)/share/dgit-infrastructure/debian
txtdocdir=$(prefix)/share/doc/dgit
sharedir=$(prefix)/share/dgit
absurddir=$(sharedir)/absurd

PROGRAMS=dgit git-playtree-setup mini-git-tag-fsck \
	tag2upload-fetch-inputs tag2upload-obtain-origs
MAN1PAGES=dgit.1
SHAREFILES=dgit-functions.sh

MAN7PAGES=dgit.7				\
	dgit-user.7 dgit-nmu-simple.7		\
	dgit-maint-native.7			\
	dgit-maint-merge.7 dgit-maint-gbp.7	\
	dgit-maint-debrebase.7                  \
	dgit-downstream-dsc.7			\
	dgit-sponsorship.7			\
	dgit-maint-bpo.7

TXTDOCS=README.dsc-import
PERLMODULES= \
	Debian/Dgit.pm \
	Debian/Dgit/Core.pm \
	Debian/Dgit/ExitStatus.pm \
	Debian/Dgit/I18n.pm \
	Debian/Dgit/ProtoConn.pm
ABSURDITIES=git

GDR_PROGRAMS=git-debrebase
GDR_PERLMODULES= \
	Debian/Dgit.pm \
	Debian/Dgit/Core.pm \
	Debian/Dgit/GDR.pm \
	Debian/Dgit/ExitStatus.pm \
	Debian/Dgit/I18n.pm
GDR_MAN1PAGES=git-debrebase.1
GDR_MAN5PAGES=git-debrebase.5

GDP_PROGRAMS=git-debpush git-deborig
GDP_PERLMODULES= \
	Debian/Dgit/Core.pm \
	Debian/Dgit/GDP.pm \
	Debian/Dgit/I18n.pm
GDP_MAN1PAGES=git-debpush.1 git-deborig.1
GDP_MAN5PAGES=tag2upload.5

INFRA_PROGRAMS=dgit-repos-server dgit-ssh-dispatch dgit-mirror-ssh-wrap \
	dgit-repos-policy-debian dgit-repos-admin-debian \
	dgit-repos-policy-trusting dgit-mirror-rsync \
	tag2upload-oracled
INFRA_EXAMPLES=get-dm-txt ssh-wrap drs-cron-wrap get-suites
INFRA_DEBIAN=get-dm-txt tag2upload-builder-rebuild \
	tag2upload-oracle-crontab tag2upload-builder-crontab
INFRA_PERLMODULES= \
	Debian/Dgit.pm \
	Debian/Dgit/Core.pm \
	Debian/Dgit/Infra.pm \
	Debian/Dgit/Policy/Debian.pm \
	Debian/Dgit/ProtoConn.pm

MANPAGES=$(MAN1PAGES) $(MAN5PAGES) $(MAN7PAGES) \
	$(GDR_MAN1PAGES) $(GDR_MAN5PAGES) \
	$(GDP_MAN1PAGES) $(GDP_MAN5PAGES)

all:	$(MANPAGES) $(addprefix substituted/,$(PROGRAMS))

substituted/%:	%
	mkdir -p substituted
	set -x; perl -pe 'next unless m/###substituted###/; s{\bundef\b}{'\''$(sharedir)'\''}; s{(?<=^sharedir=)\S+(?=\s)}{'$(sharedir)'};' \
		<$< >$@

install:	installdirs all
	$(INSTALL_PROGRAM) $(addprefix substituted/,$(PROGRAMS)) \
		$(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) $(addprefix absurd/,$(ABSURDITIES)) \
		$(DESTDIR)$(absurddir)
	$(INSTALL_DATA) $(SHAREFILES) $(DESTDIR)$(sharedir)
	$(INSTALL_DATA) $(MAN1PAGES) $(DESTDIR)$(man1dir)
	$(INSTALL_DATA) $(MAN7PAGES) $(DESTDIR)$(man7dir)
	$(INSTALL_DATA) $(TXTDOCS) $(DESTDIR)$(txtdocdir)
	set -e; for m in $(PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

installdirs:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
		$(DESTDIR)$(man1dir) $(DESTDIR)$(man5dir) \
		$(DESTDIR)$(man7dir) \
		$(DESTDIR)$(txtdocdir) $(DESTDIR)$(absurddir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(PERLMODULES)))

install-gdp:    installdirs-gdp
	$(INSTALL_PROGRAM) $(GDP_PROGRAMS) $(DESTDIR)$(bindir)
	$(INSTALL_DATA) $(GDP_MAN1PAGES) $(DESTDIR)$(man1dir)
	$(INSTALL_DATA) $(GDP_MAN5PAGES) $(DESTDIR)$(man5dir)
	set -e; for m in $(GDP_PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

install-gdr:	installdirs-gdr
	$(INSTALL_PROGRAM) $(GDR_PROGRAMS) $(DESTDIR)$(bindir)
	$(INSTALL_DATA) $(GDR_MAN1PAGES) $(DESTDIR)$(man1dir)
	$(INSTALL_DATA) $(GDR_MAN5PAGES) $(DESTDIR)$(man5dir)
	set -e; for m in $(GDR_PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

install-infra:	installdirs-infra
	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_PROGRAMS)) \
		$(DESTDIR)$(bindir)
	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_EXAMPLES)) \
		$(DESTDIR)$(infraexamplesdir)
	$(INSTALL_PROGRAM) $(addprefix infra/, $(INFRA_DEBIAN)) \
		$(DESTDIR)$(infradebiandir)
	set -e; for m in $(INFRA_PERLMODULES); do \
		$(INSTALL_DATA) $$m $(DESTDIR)$(perldir)/$${m%/*}; \
	done

installdirs-gdp:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
		$(DESTDIR)$(man1dir) $(DESTDIR)$(man5dir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(GDR_PERLMODULES)))

installdirs-gdr:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
		$(DESTDIR)$(man1dir) $(DESTDIR)$(man5dir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(GDR_PERLMODULES)))

installdirs-infra:
	$(INSTALL_DIR) $(DESTDIR)$(bindir) \
		$(DESTDIR)$(infraexamplesdir) $(DESTDIR)$(infradebiandir) \
		$(addprefix $(DESTDIR)$(perldir)/, $(dir $(INFRA_PERLMODULES)))

list-manpages:
	@echo $(MANPAGES)

i18n i18n-update:
	$(MAKE) -C po update
	$(MAKE) -C po4a update

# When tests/tests/i18n-po4a-uptodate fails, this target will usually fix it.
i18n-commit:
	set -e; x=$$(git status --porcelain); set -x; test "x$$x" = x
	$(MAKE) i18n-update
	git add po4a/*_[0-9].pot
	git clean -xdff po4a/\*.po
	git commit -a -m 'i18n-commit - autogenerated'

check installcheck:

clean distclean mostlyclean maintainer-clean:
	rm -rf tests/tmp substituted
	set -e; for m in $(MANPAGES); do \
		test -e $$m.pod && rm -f $$m; \
	done

dgit%: dgit%.pod
	m="$(notdir $@)"; $(POD2MAN)				\
		--center=dgit					\
		--name="$${m%.[0-9]}"				\
		--section="$${m##*.}"				\
		$^ $@

%: %.pod
	m="$(notdir $@)"; $(POD2MAN)				\
		--center="$${m%.[0-9]}"				\
		--name="$${m%.[0-9]}"				\
		--section="$${m##*.}"				\
		$^ $@

%.view:	%
	man -l $*
